"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const core_1 = require("@ts-ioc/core");
/**
 * runnable options token.
 */
exports.RunnableOptionsToken = new core_1.InjectToken('boot_runnable_options');
/**
 * boot.
 *
 * @export
 * @class Boot
 * @implements {IBoot<T>}
 * @template T
 */
let RunnableBase = class RunnableBase {
    constructor(options) {
        this.options = options;
    }
    getTarget() {
        return this.options.instance;
    }
    getModuleToken() {
        return this.options.mdToken;
    }
    getTargetType() {
        return this.options.type || core_1.lang.getClass(this.options.instance);
    }
    static getClassAnnations() {
        return { "name": "RunnableBase", "params": { "constructor": ["options"], "getTarget": [], "getModuleToken": [], "getTargetType": [] } };
    }
};
tslib_1.__decorate([
    core_1.Inject(core_1.ContainerToken),
    tslib_1.__metadata("design:type", Object)
], RunnableBase.prototype, "container", void 0);
RunnableBase = tslib_1.__decorate([
    tslib_1.__param(0, core_1.Inject(exports.RunnableOptionsToken)),
    tslib_1.__metadata("design:paramtypes", [Object])
], RunnableBase);
exports.RunnableBase = RunnableBase;
/**
 * target is Runnable or not.
 *
 * @export
 * @param {*} target
 * @returns {target is RunnableBase<any>}
 */
function isRunnable(target) {
    if (target instanceof RunnableBase) {
        return true;
    }
    return false;
}
exports.isRunnable = isRunnable;

//# sourceMappingURL=../sourcemaps/runnable/Runnable.js.map
