"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const core_1 = require("@ts-ioc/core");
const Runnable_1 = require("./Runnable");
/**
 * boot element.
 *
 * @export
 * @abstract
 * @class Boot
 * @implements {IBoot}
 */
let Runner = class Runner extends Runnable_1.RunnableBase {
    constructor(options) {
        super(options);
    }
    static getClassAnnations() {
        return { "name": "Runner", "params": { "constructor": ["options"], "run": ["data"] } };
    }
};
Runner = tslib_1.__decorate([
    tslib_1.__param(0, core_1.Inject(Runnable_1.RunnableOptionsToken)),
    tslib_1.__metadata("design:paramtypes", [Object])
], Runner);
exports.Runner = Runner;
/**
 * target is runner or not.
 *
 * @export
 * @param {*} target
 * @returns {target is IRunner<any>}
 */
function isRunner(target) {
    if (target instanceof Runner) {
        return true;
    }
    if (target && core_1.isFunction(target.run)) {
        return true;
    }
    return false;
}
exports.isRunner = isRunner;

//# sourceMappingURL=../sourcemaps/runnable/Runner.js.map
