"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@ts-ioc/core");
var Runnable_1 = require("./Runnable");
/**
 * base service.
 *
 * @export
 * @abstract
 * @class Service
 * @implements {IService}
 */
var Service = /** @class */ (function (_super) {
    tslib_1.__extends(Service, _super);
    function Service(options) {
        return _super.call(this, options) || this;
    }
    Service.getClassAnnations = function () {
        return { "name": "Service", "params": { "constructor": ["options"], "start": ["data"], "stop": [] } };
    };
    Service = tslib_1.__decorate([
        tslib_1.__param(0, core_1.Inject(Runnable_1.RunnableOptionsToken)),
        tslib_1.__metadata("design:paramtypes", [Object])
    ], Service);
    return Service;
}(Runnable_1.RunnableBase));
exports.Service = Service;
/**
 * target is service or not.
 *
 * @export
 * @param {*} target
 * @returns {target is IService<any>}
 */
function isService(target) {
    if (target instanceof Service) {
        return true;
    }
    if (target && core_1.isFunction(target.start)) {
        return true;
    }
    return false;
}
exports.isService = isService;

//# sourceMappingURL=../sourcemaps/runnable/Service.js.map
